/**
 * <copyright>
 * </copyright>
 *
 * $Id: SQLXMLQueryModelFactory.java,v 1.1 2007/06/25 16:29:55 jgraham Exp $
 */
package org.eclipse.datatools.modelbase.sql.xml.query;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.eclipse.datatools.modelbase.sql.xml.query.SQLXMLQueryModelPackage
 * @generated
 */
public interface SQLXMLQueryModelFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    SQLXMLQueryModelFactory eINSTANCE = org.eclipse.datatools.modelbase.sql.xml.query.impl.SQLXMLQueryModelFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>XML Value Function Concat</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Concat</em>'.
	 * @generated
	 */
    XMLValueFunctionConcat createXMLValueFunctionConcat();

	/**
	 * Returns a new object of class '<em>XML Namespace Declaration Prefix</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Namespace Declaration Prefix</em>'.
	 * @generated
	 */
    XMLNamespaceDeclarationPrefix createXMLNamespaceDeclarationPrefix();

	/**
	 * Returns a new object of class '<em>XML Namespace Declaration Default</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Namespace Declaration Default</em>'.
	 * @generated
	 */
    XMLNamespaceDeclarationDefault createXMLNamespaceDeclarationDefault();

	/**
	 * Returns a new object of class '<em>XML Attribute Declaration Item</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Attribute Declaration Item</em>'.
	 * @generated
	 */
    XMLAttributeDeclarationItem createXMLAttributeDeclarationItem();

	/**
	 * Returns a new object of class '<em>XML Value Function Element</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Element</em>'.
	 * @generated
	 */
    XMLValueFunctionElement createXMLValueFunctionElement();

	/**
	 * Returns a new object of class '<em>XML Namespace Declaration Item</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Namespace Declaration Item</em>'.
	 * @generated
	 */
    XMLNamespaceDeclarationItem createXMLNamespaceDeclarationItem();

	/**
	 * Returns a new object of class '<em>XML Value Function Element Content Item</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Element Content Item</em>'.
	 * @generated
	 */
    XMLValueFunctionElementContentItem createXMLValueFunctionElementContentItem();

	/**
	 * Returns a new object of class '<em>XML Value Function Forest</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Forest</em>'.
	 * @generated
	 */
    XMLValueFunctionForest createXMLValueFunctionForest();

	/**
	 * Returns a new object of class '<em>XML Value Function Comment</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Comment</em>'.
	 * @generated
	 */
    XMLValueFunctionComment createXMLValueFunctionComment();

	/**
	 * Returns a new object of class '<em>XML Value Function Document</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Document</em>'.
	 * @generated
	 */
    XMLValueFunctionDocument createXMLValueFunctionDocument();

	/**
	 * Returns a new object of class '<em>XML Value Function Parse</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Parse</em>'.
	 * @generated
	 */
    XMLValueFunctionParse createXMLValueFunctionParse();

	/**
	 * Returns a new object of class '<em>XML Value Function PI</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function PI</em>'.
	 * @generated
	 */
    XMLValueFunctionPI createXMLValueFunctionPI();

	/**
	 * Returns a new object of class '<em>XML Value Function Query</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Query</em>'.
	 * @generated
	 */
    XMLValueFunctionQuery createXMLValueFunctionQuery();

	/**
	 * Returns a new object of class '<em>XML Value Function Text</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Text</em>'.
	 * @generated
	 */
    XMLValueFunctionText createXMLValueFunctionText();

	/**
	 * Returns a new object of class '<em>XML Value Function Validate</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Validate</em>'.
	 * @generated
	 */
    XMLValueFunctionValidate createXMLValueFunctionValidate();

	/**
	 * Returns a new object of class '<em>XML Value Expression Cast</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Expression Cast</em>'.
	 * @generated
	 */
    XMLValueExpressionCast createXMLValueExpressionCast();

	/**
	 * Returns a new object of class '<em>XML Predicate Content</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Predicate Content</em>'.
	 * @generated
	 */
    XMLPredicateContent createXMLPredicateContent();

	/**
	 * Returns a new object of class '<em>XML Predicate Document</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Predicate Document</em>'.
	 * @generated
	 */
    XMLPredicateDocument createXMLPredicateDocument();

	/**
	 * Returns a new object of class '<em>XML Predicate Exists</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Predicate Exists</em>'.
	 * @generated
	 */
    XMLPredicateExists createXMLPredicateExists();

	/**
	 * Returns a new object of class '<em>XML Predicate Valid</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Predicate Valid</em>'.
	 * @generated
	 */
    XMLPredicateValid createXMLPredicateValid();

	/**
	 * Returns a new object of class '<em>XML Query Expression</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Query Expression</em>'.
	 * @generated
	 */
    XMLQueryExpression createXMLQueryExpression();

	/**
	 * Returns a new object of class '<em>XML Query Argument List</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Query Argument List</em>'.
	 * @generated
	 */
    XMLQueryArgumentList createXMLQueryArgumentList();

	/**
	 * Returns a new object of class '<em>XML Query Argument Item</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Query Argument Item</em>'.
	 * @generated
	 */
    XMLQueryArgumentItem createXMLQueryArgumentItem();

	/**
	 * Returns a new object of class '<em>XML Serialize Function</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Serialize Function</em>'.
	 * @generated
	 */
    XMLSerializeFunction createXMLSerializeFunction();

	/**
	 * Returns a new object of class '<em>XML Serialize Function Target</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Serialize Function Target</em>'.
	 * @generated
	 */
    XMLSerializeFunctionTarget createXMLSerializeFunctionTarget();

	/**
	 * Returns a new object of class '<em>XML Aggregate Function</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Aggregate Function</em>'.
	 * @generated
	 */
    XMLAggregateFunction createXMLAggregateFunction();

	/**
	 * Returns a new object of class '<em>XML Value Function Concat Content Item</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Concat Content Item</em>'.
	 * @generated
	 */
    XMLValueFunctionConcatContentItem createXMLValueFunctionConcatContentItem();

	/**
	 * Returns a new object of class '<em>XML Value Function Comment Content</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Comment Content</em>'.
	 * @generated
	 */
    XMLValueFunctionCommentContent createXMLValueFunctionCommentContent();

	/**
	 * Returns a new object of class '<em>XML Value Function Document Content</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Document Content</em>'.
	 * @generated
	 */
    XMLValueFunctionDocumentContent createXMLValueFunctionDocumentContent();

	/**
	 * Returns a new object of class '<em>XML Aggregate Sort Specification</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Aggregate Sort Specification</em>'.
	 * @generated
	 */
    XMLAggregateSortSpecification createXMLAggregateSortSpecification();

	/**
	 * Returns a new object of class '<em>XML Value Function Forest Content Item</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Forest Content Item</em>'.
	 * @generated
	 */
    XMLValueFunctionForestContentItem createXMLValueFunctionForestContentItem();

	/**
	 * Returns a new object of class '<em>XML Value Function Parse Content</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Parse Content</em>'.
	 * @generated
	 */
    XMLValueFunctionParseContent createXMLValueFunctionParseContent();

	/**
	 * Returns a new object of class '<em>XML Value Function PI Content</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function PI Content</em>'.
	 * @generated
	 */
    XMLValueFunctionPIContent createXMLValueFunctionPIContent();

	/**
	 * Returns a new object of class '<em>XML Table Function</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Table Function</em>'.
	 * @generated
	 */
    XMLTableFunction createXMLTableFunction();

	/**
	 * Returns a new object of class '<em>XML Value Function Text Content</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Text Content</em>'.
	 * @generated
	 */
    XMLValueFunctionTextContent createXMLValueFunctionTextContent();

	/**
	 * Returns a new object of class '<em>XML Value Function Validate Content</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Validate Content</em>'.
	 * @generated
	 */
    XMLValueFunctionValidateContent createXMLValueFunctionValidateContent();

	/**
	 * Returns a new object of class '<em>XML Table Column Definition Item</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Table Column Definition Item</em>'.
	 * @generated
	 */
    XMLTableColumnDefinitionItem createXMLTableColumnDefinitionItem();

	/**
	 * Returns a new object of class '<em>XML Table Column Definition Regular</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Table Column Definition Regular</em>'.
	 * @generated
	 */
    XMLTableColumnDefinitionRegular createXMLTableColumnDefinitionRegular();

	/**
	 * Returns a new object of class '<em>XML Table Column Definition Ordinality</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Table Column Definition Ordinality</em>'.
	 * @generated
	 */
    XMLTableColumnDefinitionOrdinality createXMLTableColumnDefinitionOrdinality();

	/**
	 * Returns a new object of class '<em>XML Value Function Validate According To</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Validate According To</em>'.
	 * @generated
	 */
    XMLValueFunctionValidateAccordingTo createXMLValueFunctionValidateAccordingTo();

	/**
	 * Returns a new object of class '<em>XML Value Function Validate According To URI</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Validate According To URI</em>'.
	 * @generated
	 */
    XMLValueFunctionValidateAccordingToURI createXMLValueFunctionValidateAccordingToURI();

	/**
	 * Returns a new object of class '<em>XML Value Function Validate According To Identifier</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Validate According To Identifier</em>'.
	 * @generated
	 */
    XMLValueFunctionValidateAccordingToIdentifier createXMLValueFunctionValidateAccordingToIdentifier();

	/**
	 * Returns a new object of class '<em>XML Value Function Validate Element Name</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Validate Element Name</em>'.
	 * @generated
	 */
    XMLValueFunctionValidateElementName createXMLValueFunctionValidateElementName();

	/**
	 * Returns a new object of class '<em>XML Value Function Validate Element Namespace</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Validate Element Namespace</em>'.
	 * @generated
	 */
    XMLValueFunctionValidateElementNamespace createXMLValueFunctionValidateElementNamespace();

	/**
	 * Returns a new object of class '<em>XML Namespaces Declaration</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Namespaces Declaration</em>'.
	 * @generated
	 */
    XMLNamespacesDeclaration createXMLNamespacesDeclaration();

	/**
	 * Returns a new object of class '<em>XML Attributes Declaration</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Attributes Declaration</em>'.
	 * @generated
	 */
    XMLAttributesDeclaration createXMLAttributesDeclaration();

	/**
	 * Returns a new object of class '<em>XML Value Function Element Content List</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Element Content List</em>'.
	 * @generated
	 */
    XMLValueFunctionElementContentList createXMLValueFunctionElementContentList();

	/**
	 * Returns a new object of class '<em>XML Value Function Query Returning</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Query Returning</em>'.
	 * @generated
	 */
    XMLValueFunctionQueryReturning createXMLValueFunctionQueryReturning();

	/**
	 * Returns a new object of class '<em>XML Value Function Validate Element</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Value Function Validate Element</em>'.
	 * @generated
	 */
    XMLValueFunctionValidateElement createXMLValueFunctionValidateElement();

	/**
	 * Returns a new object of class '<em>XML Table Column Definition Default</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Table Column Definition Default</em>'.
	 * @generated
	 */
    XMLTableColumnDefinitionDefault createXMLTableColumnDefinitionDefault();

	/**
	 * Returns a new object of class '<em>XML Serialize Function Encoding</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>XML Serialize Function Encoding</em>'.
	 * @generated
	 */
    XMLSerializeFunctionEncoding createXMLSerializeFunctionEncoding();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	SQLXMLQueryModelPackage getSQLXMLQueryModelPackage();

} //SQLXMLQueryFactory
