/*******************************************************************************
 * Copyright (c) 2005 Sybase, Inc.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Sybase, Inc. - initial API and implementation
 *******************************************************************************/
package org.eclipse.datatools.sqltools.plan;

/**
 * 
 * This file contains all the context help ID that are used by following DTP plugins:
 * 
 * TPS_helpKey_constants_for_plug-in: org.eclipse.datatools.sqltools.plan
 * 
 * @author lihuang
 */
public interface IHelpConstants
{

    public static final String PREFIX                    = "org.eclipse.datatools.sqltools.plan.";

    /**
     * Used for plan view.
     */
    public static final String PLAN_VIEW                 = PREFIX + "plan_view";

    /**
     * Used for execution plan preference page
     */
    public static final String EXECUTION_PLAN_PREFERENCE = PREFIX + "execution_plan_preference";

    /**
     * Used for remove plan action
     */
    public static final String REMOVE_PLAN_ACTION        = PREFIX + "remove_plan_action";

    /**
     * Used for remove all plan action
     */
    public static final String REMOVE_ALL_PLAN_ACTION    = PREFIX + "remove_all_plan_action";

    /**
     * Used for plan drop down action
     */
    public static final String PLAN_DROP_DOWN_ACTION     = PREFIX + "plan_drop_down_action";

    /**
     * Used for save plan action
     */
    public static final String SAVE_PLAN_ACTION          = PREFIX + "save_plan_action";

    /**
     * Used for load plan action
     */
    public static final String LOAD_PLAN_ACTION          = PREFIX + "load_plan_action";

}
