/*******************************************************************************
 * Copyright (c) 2006 NEC Soft, Ltd.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     NEC Soft, Ltd.- initial API and implementation
 *******************************************************************************/
package org.eclipse.datatools.sqltools.tablewizard.ui.popup.actions;

import org.eclipse.datatools.connectivity.IConnectionProfile;
import org.eclipse.datatools.connectivity.sqm.core.internal.ui.explorer.virtual.ITableNode;
import org.eclipse.datatools.modelbase.sql.schema.Schema;
import org.eclipse.datatools.sqltools.tablewizard.ui.wizards.GenericTableDefinitionWizard;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.ITreeSelection;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.IActionDelegate;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;

public class NewTableWizardAction implements IObjectActionDelegate {
	
	private ISelection selection = null;
	
	/**
	 * Constructor for Action1.
	 */
	public NewTableWizardAction() {
		super();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {
		if (!(this.selection instanceof ITreeSelection)) {
			return;
		}
		try {
			Display display = Display.getCurrent();

			ITreeSelection ss = (ITreeSelection) this.selection;
			ITableNode node = (ITableNode) ss.getFirstElement();
			IConnectionProfile profile = (IConnectionProfile) ss.getPaths()[0]
					.getSegment(1);
			Schema schema = (Schema) node.getParent();

			GenericTableDefinitionWizard wizard = new GenericTableDefinitionWizard(profile, schema);
			WizardDialog dialog = new WizardDialog(display.getActiveShell(),
					wizard);
			dialog.create();
			dialog.getShell().pack();
			dialog.open();
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	/**
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection) {
		this.selection = selection;
	}

}
